groovy.util.slurpersupport

## Class Attributes

- java.lang.Object
- - groovy.lang.GroovyObjectSupport
  - - groovy.util.slurpersupport.GPathResult
    - - groovy.util.slurpersupport.NodeChildren
      - - groovy.util.slurpersupport.Attributes

- All Implemented Interfaces:
    Buildable, GroovyObject, Writable, java.lang.Iterable
  Direct Known Subclasses:
    FilteredAttributes

      public class Attributes
      extends NodeChildren

  Lazy evaluated representation of a node's attributes.
  Author:
    John Wilson

- - ### Field Summary

    - ### Fields inherited from class groovy.util.slurpersupport.GPathResult

      `name, namespaceMap, namespacePrefix, namespaceTagHints, parent`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Attributes(GPathResult parent, java.lang.String name, java.util.Map<java.lang.String,java.lang.String> namespaceTagHints)`
    `Attributes(GPathResult parent, java.lang.String name, java.lang.String namespacePrefix, java.util.Map<java.lang.String,java.lang.String> namespaceTagHints)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `build(GroovyObject builder)`
    `java.util.Iterator` | `childNodes()` Throws a `GroovyRuntimeException`, because attributes can have no children.
    `GPathResult` | `findAll(Closure closure)` Returns the children of this GPathResult matching the condition(s) specified in the passed closure.
    `java.util.Iterator` | `iterator()`
    `java.util.List` | `list()` Creates a list of objects representing this GPathResult.
    `java.lang.String` | `name()` Returns the name of this GPathResult.
    `java.util.Iterator` | `nodeIterator()`
    `GPathResult` | `parents()` Throws a `GroovyRuntimeException`, because it is not implemented yet.
    `java.lang.String` | `text()` Returns the text of this GPathResult as a `String`.
    `java.io.Writer` | `writeTo(java.io.Writer out)` Writes this object to the given writer.

    - ### Methods inherited from class groovy.util.slurpersupport.NodeChildren

      `appendNode, find, replaceBody, replaceNode, size`

    - ### Methods inherited from class groovy.util.slurpersupport.GPathResult

      `breadthFirst, children, declareNamespace, depthFirst, equals, getAt, getAt, getBody, getProperty, hashCode, isEmpty, leftShift, lookupNamespace, parent, plus, pop, putAt, setMetaClass, setProperty, toBigDecimal, toBigInteger, toBoolean, toDouble, toFloat, toInteger, toLong, toString, toURI, toURL`

    - ### Methods inherited from class groovy.lang.GroovyObjectSupport

      `getMetaClass, invokeMethod`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

- - ### Constructor Detail

    - #### Attributes

          public Attributes(GPathResult parent,
                            java.lang.String name,
                            java.lang.String namespacePrefix,
                            java.util.Map<java.lang.String,java.lang.String> namespaceTagHints)

      Parameters:
        `parent` - the GPathResult prior to the application of the expression creating this GPathResult
        `name` - if the GPathResult corresponds to something with a name, e.g. a node
        `namespacePrefix` - the namespace prefix if any
        `namespaceTagHints` - the known tag to namespace mappings

    - #### Attributes

          public Attributes(GPathResult parent,
                            java.lang.String name,
                            java.util.Map<java.lang.String,java.lang.String> namespaceTagHints)

      Parameters:
        `parent` - the GPathResult prior to the application of the expression creating this GPathResult
        `name` - if the GPathResult corresponds to something with a name, e.g. a node
        `namespaceTagHints` - the known tag to namespace mappings

  - ### Method Detail

    - #### name

          public java.lang.String name()

      Description copied from class: `GPathResult`
      Returns the name of this GPathResult.
      Overrides:
        `name` in class `GPathResult`
      Returns:
        the name of this GPathResult

    - #### childNodes

          public java.util.Iterator childNodes()

      Throws a `GroovyRuntimeException`, because attributes can have no children.
      Overrides:
        `childNodes` in class `NodeChildren`
      Returns:
        an iterator over the child nodes of this GPathResult

    - #### iterator

          public java.util.Iterator iterator()

      Specified by:
        `iterator` in interface `java.lang.Iterable`
      Overrides:
        `iterator` in class `NodeChildren`

    - #### nodeIterator

          public java.util.Iterator nodeIterator()

      Overrides:
        `nodeIterator` in class `NodeChildren`

    - #### parents

          public GPathResult parents()

      Description copied from class: `NodeChildren`
      Throws a `GroovyRuntimeException`, because it is not implemented yet.
      Overrides:
        `parents` in class `NodeChildren`
      Returns:
        the parents of this GPathResult

    - #### text

          public java.lang.String text()

      Description copied from class: `GPathResult`
      Returns the text of this GPathResult as a `String`.
      Overrides:
        `text` in class `NodeChildren`
      Returns:
        the text of this GPathResult

    - #### list

          public java.util.List list()

      Description copied from class: `GPathResult`
      Creates a list of objects representing this GPathResult.
      Overrides:
        `list` in class `GPathResult`
      Returns:
        a list representing of this GPathResult

    - #### findAll

          public GPathResult findAll(Closure closure)

      Description copied from class: `GPathResult`
      Returns the children of this GPathResult matching the condition(s) specified in the passed closure.
      Overrides:
        `findAll` in class `NodeChildren`
      Parameters:
        `closure` - a closure to filters the children of this GPathResult
      Returns:
        the children matching the closure

    - #### writeTo

          public java.io.Writer writeTo(java.io.Writer out)
                                 throws java.io.IOException

      Description copied from interface: `Writable`
      Writes this object to the given writer.

      This is used to defer content creation until the point when it is streamed to the output destination. Oftentimes, content will be defined but not necessarily created (as is may be the case with a Closure definition.) In that case, the output is then 'deferred' to the point when it is serialized to the writer. This class may be used whenever an object should be responsible for creating its own textual representation, but creating the entire output as a single String would be inefficient (such as outputting a multi-gigabyte XML document.)

      Specified by:
        `writeTo` in interface `Writable`
      Overrides:
        `writeTo` in class `NodeChildren`
      Parameters:
        `out` - the Writer to which this Writable should output its data.
      Returns:
        the Writer that was passed
      Throws:
        `java.io.IOException` - if an error occurred while outputting data to the writer

    - #### build

          public void build(GroovyObject builder)

      Specified by:
        `build` in interface `Buildable`
      Overrides:
        `build` in class `NodeChildren`